// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: essmodule/essmodule.proto

package openfmb.essmodule;

public interface ESSFunctionOrBuilder extends
    // @@protoc_insertion_point(interface_extends:essmodule.ESSFunction)
    com.google.protobuf.MessageOrBuilder {

  /**
   * <pre>
   * ESS inverter high level function to reduce (smooth) charging or discharging rate of change.
   * </pre>
   *
   * <code>.essmodule.CapacityFirming capacityFirming = 1;</code>
   * @return Whether the capacityFirming field is set.
   */
  boolean hasCapacityFirming();
  /**
   * <pre>
   * ESS inverter high level function to reduce (smooth) charging or discharging rate of change.
   * </pre>
   *
   * <code>.essmodule.CapacityFirming capacityFirming = 1;</code>
   * @return The capacityFirming.
   */
  openfmb.essmodule.CapacityFirming getCapacityFirming();
  /**
   * <pre>
   * ESS inverter high level function to reduce (smooth) charging or discharging rate of change.
   * </pre>
   *
   * <code>.essmodule.CapacityFirming capacityFirming = 1;</code>
   */
  openfmb.essmodule.CapacityFirmingOrBuilder getCapacityFirmingOrBuilder();

  /**
   * <pre>
   * ESS inverter high level function to maintain frequency within dead bands.
   * </pre>
   *
   * <code>.essmodule.FrequencyRegulation frequencyRegulation = 2;</code>
   * @return Whether the frequencyRegulation field is set.
   */
  boolean hasFrequencyRegulation();
  /**
   * <pre>
   * ESS inverter high level function to maintain frequency within dead bands.
   * </pre>
   *
   * <code>.essmodule.FrequencyRegulation frequencyRegulation = 2;</code>
   * @return The frequencyRegulation.
   */
  openfmb.essmodule.FrequencyRegulation getFrequencyRegulation();
  /**
   * <pre>
   * ESS inverter high level function to maintain frequency within dead bands.
   * </pre>
   *
   * <code>.essmodule.FrequencyRegulation frequencyRegulation = 2;</code>
   */
  openfmb.essmodule.FrequencyRegulationOrBuilder getFrequencyRegulationOrBuilder();

  /**
   * <pre>
   * ESS inverter high level function to maintain power level by charging or discharging
   * </pre>
   *
   * <code>.essmodule.PeakShaving peakShaving = 3;</code>
   * @return Whether the peakShaving field is set.
   */
  boolean hasPeakShaving();
  /**
   * <pre>
   * ESS inverter high level function to maintain power level by charging or discharging
   * </pre>
   *
   * <code>.essmodule.PeakShaving peakShaving = 3;</code>
   * @return The peakShaving.
   */
  openfmb.essmodule.PeakShaving getPeakShaving();
  /**
   * <pre>
   * ESS inverter high level function to maintain power level by charging or discharging
   * </pre>
   *
   * <code>.essmodule.PeakShaving peakShaving = 3;</code>
   */
  openfmb.essmodule.PeakShavingOrBuilder getPeakShavingOrBuilder();

  /**
   * <pre>
   * ESS inverter high level function to shut down ESS if SOC exceeds high or low limits.
   * </pre>
   *
   * <code>.essmodule.SocLimit socLimit = 4;</code>
   * @return Whether the socLimit field is set.
   */
  boolean hasSocLimit();
  /**
   * <pre>
   * ESS inverter high level function to shut down ESS if SOC exceeds high or low limits.
   * </pre>
   *
   * <code>.essmodule.SocLimit socLimit = 4;</code>
   * @return The socLimit.
   */
  openfmb.essmodule.SocLimit getSocLimit();
  /**
   * <pre>
   * ESS inverter high level function to shut down ESS if SOC exceeds high or low limits.
   * </pre>
   *
   * <code>.essmodule.SocLimit socLimit = 4;</code>
   */
  openfmb.essmodule.SocLimitOrBuilder getSocLimitOrBuilder();

  /**
   * <pre>
   * ESS inverter high level function to maintain SOC within dead bands
   * </pre>
   *
   * <code>.essmodule.SOCManagement socManagement = 5;</code>
   * @return Whether the socManagement field is set.
   */
  boolean hasSocManagement();
  /**
   * <pre>
   * ESS inverter high level function to maintain SOC within dead bands
   * </pre>
   *
   * <code>.essmodule.SOCManagement socManagement = 5;</code>
   * @return The socManagement.
   */
  openfmb.essmodule.SOCManagement getSocManagement();
  /**
   * <pre>
   * ESS inverter high level function to maintain SOC within dead bands
   * </pre>
   *
   * <code>.essmodule.SOCManagement socManagement = 5;</code>
   */
  openfmb.essmodule.SOCManagementOrBuilder getSocManagementOrBuilder();

  /**
   * <pre>
   * ESS inverter high level function to maintain voltage within droop dead bands.
   * </pre>
   *
   * <code>.essmodule.VoltageDroop voltageDroop = 6;</code>
   * @return Whether the voltageDroop field is set.
   */
  boolean hasVoltageDroop();
  /**
   * <pre>
   * ESS inverter high level function to maintain voltage within droop dead bands.
   * </pre>
   *
   * <code>.essmodule.VoltageDroop voltageDroop = 6;</code>
   * @return The voltageDroop.
   */
  openfmb.essmodule.VoltageDroop getVoltageDroop();
  /**
   * <pre>
   * ESS inverter high level function to maintain voltage within droop dead bands.
   * </pre>
   *
   * <code>.essmodule.VoltageDroop voltageDroop = 6;</code>
   */
  openfmb.essmodule.VoltageDroopOrBuilder getVoltageDroopOrBuilder();

  /**
   * <pre>
   * ESS inverter high level function to maintain voltage within dead bands.
   * </pre>
   *
   * <code>.essmodule.VoltagePI voltagePI = 7;</code>
   * @return Whether the voltagePI field is set.
   */
  boolean hasVoltagePI();
  /**
   * <pre>
   * ESS inverter high level function to maintain voltage within dead bands.
   * </pre>
   *
   * <code>.essmodule.VoltagePI voltagePI = 7;</code>
   * @return The voltagePI.
   */
  openfmb.essmodule.VoltagePI getVoltagePI();
  /**
   * <pre>
   * ESS inverter high level function to maintain voltage within dead bands.
   * </pre>
   *
   * <code>.essmodule.VoltagePI voltagePI = 7;</code>
   */
  openfmb.essmodule.VoltagePIOrBuilder getVoltagePIOrBuilder();
}
